"""Add disk HDD Standby force option

Revision ID: dcf5c178714b
Revises: aa9810be100c
Create Date: 2019-11-28 20:37:01.292027+00:00

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'dcf5c178714b'
down_revision = 'aa9810be100c'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('storage_disk', schema=None) as batch_op:
        batch_op.add_column(sa.Column('disk_hddstandby_force', sa.Boolean(), nullable=True))

    op.execute("UPDATE storage_disk SET disk_hddstandby_force = 0")

    with op.batch_alter_table('storage_disk', schema=None) as batch_op:
        batch_op.alter_column('disk_hddstandby_force',
               existing_type=sa.BOOLEAN(),
               nullable=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('storage_disk', schema=None) as batch_op:
        batch_op.drop_column('disk_hddstandby_force')

    # ### end Alembic commands ###
