"""gc_service_announcement

Revision ID: 39a133a04496
Revises: 133f2d9049d2
Create Date: 2020-01-14 13:26:02.169132+00:00

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '39a133a04496'
down_revision = '133f2d9049d2'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('network_globalconfiguration', schema=None) as batch_op:
        batch_op.add_column(sa.Column('gc_service_announcement', sa.Text(), nullable=True))

    defaults = '{"mdns": true, "wsd": true, "netbios": true}'
    op.execute(f"UPDATE network_globalconfiguration SET gc_service_announcement = \'{defaults}\'")

    with op.batch_alter_table('network_globalconfiguration', schema=None) as batch_op:
        batch_op.alter_column('gc_service_announcement', nullable=False)

    with op.batch_alter_table('services_cifs', schema=None) as batch_op:
        batch_op.drop_column('cifs_srv_zeroconf')

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('services_cifs', schema=None) as batch_op:
        batch_op.add_column(sa.Column('cifs_srv_zeroconf', sa.BOOLEAN(), nullable=False))

    with op.batch_alter_table('network_globalconfiguration', schema=None) as batch_op:
        batch_op.drop_column('gc_service_announcement')
    # ### end Alembic commands ###
