"""Fix migrations state

Revision ID: 4eaafe146314
Revises: 553a948ae9ec
Create Date: 2021-03-17 16:01:47.835532+00:00

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '4eaafe146314'
down_revision = '553a948ae9ec'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('directoryservice_nis')

    op.execute("UPDATE network_alias SET alias_vipv6address = '' WHERE alias_vipv6address IS NULL")
    with op.batch_alter_table('network_alias', schema=None) as batch_op:
        batch_op.alter_column('alias_vipv6address',
               existing_type=sa.VARCHAR(length=45),
               nullable=False)

    with op.batch_alter_table('services_catalog', schema=None) as batch_op:
        batch_op.alter_column('builtin',
               existing_type=sa.BOOLEAN(),
               nullable=False)

    with op.batch_alter_table('services_container', schema=None) as batch_op:
        batch_op.alter_column('enable_image_updates',
               existing_type=sa.BOOLEAN(),
               nullable=False)

    op.execute("UPDATE services_kubernetes SET cni_config = '{}' WHERE cni_config IS NULL")
    with op.batch_alter_table('services_kubernetes', schema=None) as batch_op:
        batch_op.alter_column('cni_config',
               existing_type=sa.TEXT(),
               nullable=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('services_kubernetes', schema=None) as batch_op:
        batch_op.alter_column('cni_config',
               existing_type=sa.TEXT(),
               nullable=True)

    with op.batch_alter_table('services_container', schema=None) as batch_op:
        batch_op.alter_column('enable_image_updates',
               existing_type=sa.BOOLEAN(),
               nullable=True)

    with op.batch_alter_table('services_catalog', schema=None) as batch_op:
        batch_op.alter_column('builtin',
               existing_type=sa.BOOLEAN(),
               nullable=True)

    with op.batch_alter_table('network_alias', schema=None) as batch_op:
        batch_op.alter_column('alias_vipv6address',
               existing_type=sa.VARCHAR(length=45),
               nullable=True)

    op.create_table('directoryservice_nis',
    sa.Column('id', sa.INTEGER(), nullable=False),
    sa.Column('nis_domain', sa.VARCHAR(length=120), nullable=False),
    sa.Column('nis_servers', sa.VARCHAR(length=8192), nullable=False),
    sa.Column('nis_secure_mode', sa.BOOLEAN(), nullable=False),
    sa.Column('nis_manycast', sa.BOOLEAN(), nullable=False),
    sa.Column('nis_enable', sa.BOOLEAN(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###
