"""Re-create tables with `sqlite_autoincrement`

Revision ID: 1f39ac35aaeb
Revises: af5efb72c74f
Create Date: 2023-02-07 10:33:08.436590+00:00

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '1f39ac35aaeb'
down_revision = 'af5efb72c74f'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    conn = op.get_bind()
    conn.execute("PRAGMA legacy_alter_table = TRUE")
    for name, sql in conn.execute("SELECT name, sql FROM sqlite_master WHERE type = 'table'").fetchall():
        if name in ["sqlite_sequence", "alembic_version"]:
            continue
        if "autoincrement" in sql.lower():
            continue

        with op.batch_alter_table(name, recreate='always'):
            pass

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###
