"""Remove cloud_backup bwlimit, transfers; add transfer_setting

Revision ID: 8eacd2bb3e18
Revises: 92b98613c498
Create Date: 2024-11-04 20:26:07.568238+00:00

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '8eacd2bb3e18'
down_revision = '92b98613c498'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('tasks_cloud_backup', schema=None) as batch_op:
        batch_op.add_column(sa.Column('transfer_setting', sa.String(length=16), server_default='DEFAULT', nullable=False))
        batch_op.drop_column('transfers')
        batch_op.drop_column('bwlimit')

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('tasks_cloud_backup', schema=None) as batch_op:
        batch_op.add_column(sa.Column('bwlimit', sa.TEXT(), nullable=False))
        batch_op.add_column(sa.Column('transfers', sa.INTEGER(), nullable=True))
        batch_op.drop_column('transfer_setting')

    # ### end Alembic commands ###
