"""Make vm device attributes encrypted

Revision ID: b5829f78cec3
Revises: 8eacd2bb3e18
Create Date: 2024-11-06 12:49:18.684987+00:00

"""
import json

from alembic import op

from middlewared.plugins.pwenc import encrypt

# revision identifiers, used by Alembic.
revision = 'b5829f78cec3'
down_revision = '8eacd2bb3e18'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    conn = op.get_bind()
    for device in conn.execute("SELECT * FROM vm_device").fetchall():
        attributes = json.loads(device['attributes'])

        conn.execute(
            "UPDATE vm_device SET attributes = ? WHERE id = ?",
            (encrypt(json.dumps(attributes)), device['id'])
        )

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###
